#!/bin/bash
###                                        ###
#      Created on 2/16-2014 by remote.       #
# ZAXTER. home of SI/OP all rights reserved. #
#    Last modified 3/6-2014 via remote.      #
#       Control menu for RC Project.         #
###                                        ###


#This reads data from temp file, creates time stamps and sets up initial states of SI/OP, for remote control car two.
. ./RC1temp.data
  echo A="`date +%s`" > store_stop_timeRC1.siop
   sleep .5
  echo B="`date +%s`" >> store_stop_timeRC1.siop
   sed -i "/STORE_NAME_VALUE/ c STORE_NAME_VALUE=default_store_name" RC1temp.data
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin6
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin7
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin8
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin9
. ./RC1temp.data
  echo "#Idle" > ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin6" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin7" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin8" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin9" >> ${STORE_NAME_VALUE}RC1
bs='                                              '

#This is just the header for the main menu.
header() {
clear
 tput rev
  echo "=============================================="
  echo "             Simple I/O Project.              "
  echo "     SI/OP       move_RC1.sh                  "
  echo "$bs"
 tput rmso
}

#This is the main menu, which displays SI/OP status and reads user input, for instructing remote control car two.
show_current_settings() {
. ./RC1temp.data
  OLD_INPUT_CHOICE=$(for N in  /home/siop/${PORT_CHOICE}/input/* ; do cat $N ; echo  -n " " ; done | paste -sd " "|sed 's/ /  /g')
  OLD_OUTPUT_CHOICE=$(for N in  /home/siop/${PORT_CHOICE}/output/pin6 /home/siop/${PORT_CHOICE}/output/pin7 /home/siop/${PORT_CHOICE}/output/pin8 /home/siop/${PORT_CHOICE}/output/pin9 ; do cat $N ; echo -n " " ; done| paste -sd " "|sed 's/ /  /g')
clear
  header
 tput rev
  echo -n "                  Chosen parallel "
 tput rmso
  echo -n "   $PORT_CHOICE   "
 tput rev
  echo " "
  echo "$bs"
 tput rmso
 tput rev
  echo "                 Output Pins #   6  7  8  9   "
  echo -n "        Current pin states --> "
 tput rmso
  echo -n "  $OLD_OUTPUT_CHOICE"
 tput rev
  echo " "
  echo "$bs"
  echo "           w          Forward Full Speed      "
  echo "         a   d        Left Right forward      "
  echo "         z   x        Left Right reverse      "
  echo "           s          Reverse Full Speed      "
  echo "                                              "
  echo " Type: e to end storing with option to save,  "
  echo "       c to change recording name,            "
  echo "       r to replay saved file or files,       "
  echo "       w a d z x s for direction,             "
  echo "       i for idle or p to change port,        "
  echo "       q/0 to quit then hit Enter key.        "
  echo "=============================================="
 tput rmso
  echo -n "  Date & Time:  "
date

#This processes input from menu, replacing time stamps and placement for calculating, then goes to subroutine.
  echo ""
  read SIMPLEIO_MENU
   case $SIMPLEIO_MENU in
      e|E)	end_store;;
      r|R)	replay_stored;;
      c|C)	store_replay_name;;
      p|P)	use_what_port;;
      w|W)	B=`head -1 store_stop_timeRC1.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC1.siop; Forward_Full_Speed;;
      a|A)	B=`head -1 store_stop_timeRC1.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC1.siop; Left_forward;;
      d|D)	B=`head -1 store_stop_timeRC1.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC1.siop; Right_forward;;
      z|Z)	B=`head -1 store_stop_timeRC1.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC1.siop; Left_reverse;;
      x|X)	B=`head -1 store_stop_timeRC1.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC1.siop; Right_reverse;;
      s|S)	B=`head -1 store_stop_timeRC1.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC1.siop; Reverse_Full_Speed;;
      i|I)	B=`head -1 store_stop_timeRC1.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC1.siop; Idle;;
      Q|q|0|Q/0|q/0)	B=`head -1 store_stop_timeRC1.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC1.siop; clean_up;;
   esac
 show_current_settings
}

#This ends recording of replay name and or restarts recording in default_store_name.
#Add "Would you like to save this run?" option.
end_store(){
  echo " Recording stopped for $REPLAY_NAME_VALUE and or restarted in default_store_name file. "
  echo A="`date +%s`" > store_stop_timeRC1.siop
   sleep .5
  echo B="`date +%s`" >> store_stop_timeRC1.siop
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin6
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin7
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin8
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin9
  echo "#Idle" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin6" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin7" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin8" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin9" >> ${STORE_NAME_VALUE}RC1
   sed -i "/STORE_NAME_VALUE/ c STORE_NAME_VALUE=default_store_name" RC1temp.data
 show_current_settings
}

#This request file name you wish to replay and how many times.
#Add create and run play list option.
replay_stored(){
  echo "    Type stored file name.         "
  read REPLAY_STORED
   case $REPLAY_STORED in
      [a-zA-Z0-0]*)	sed -i "/REPLAY_NAME_VALUE/ c REPLAY_NAME_VALUE=$REPLAY_STORED" RC1temp.data
   esac
  echo "    Type amount of times to replay."
  read AMOUNT_REPLAY
   case $AMOUNT_REPLAY in
      [1-99])	sed -i "/AMOUNT_REPLAY_VALUE/ c AMOUNT_REPLAY_VALUE=$AMOUNT_REPLAY" RC1temp.data
   esac
. ./RC1temp.data
  echo " Play file $REPLAY_NAME_VALUE $AMOUNT_REPLAY_VALUE times. "
  echo " Press g then Enter to go.             "
  read FILE_PLUS_AMOUNT
   case $FILE_PLUS_AMOUNT in
      g)	replay;;
   esac
replay_stored
}

#This is to execute replay.
replay(){
. ./RC1temp.data
  n=$AMOUNT_REPLAY_VALUE; for (( c=1; c<=n; c++)) ; do ./${REPLAY_NAME_VALUE}RC1 ; done
 show_current_settings
}

#This updates time stamps, switches name of store file for remote control car two, in RC1temp.data.
store_replay_name(){
. ./RC1temp.data
  echo A="`date +%s`" > store_stop_timeRC1.siop
   sleep .5
  echo B="`date +%s`" >> store_stop_timeRC1.siop
  echo "    Type file name to be stored.       "
  echo "  Currently using: $STORE_NAME_VALUE   "
  echo "   Will immediately start recording.   "
  echo " Press e then Enter to end storing.    "
  read REPLAY_STORE_NAME
   case $REPLAY_STORE_NAME in
      [a-zA-Z0-0]*)	sed -i "/STORE_NAME_VALUE/ c STORE_NAME_VALUE=$REPLAY_STORE_NAME" RC1temp.data
      echo "0" > /home/siop/${PORT_CHOICE}/output/pin6
      echo "0" > /home/siop/${PORT_CHOICE}/output/pin7
      echo "0" > /home/siop/${PORT_CHOICE}/output/pin8
      echo "0" > /home/siop/${PORT_CHOICE}/output/pin9
. ./RC1temp.data
      echo "#Idle  " > ${STORE_NAME_VALUE}RC1
	chmod 0777 ${STORE_NAME_VALUE}RC1
      echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin6" >> ${STORE_NAME_VALUE}RC1
      echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin7" >> ${STORE_NAME_VALUE}RC1
      echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin8" >> ${STORE_NAME_VALUE}RC1
      echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin9" >> ${STORE_NAME_VALUE}RC1
	show_current_settings;;
   esac
store_replay_name
}

#This is to alter which parallel port the cable is plugged into, then returns to main loop.
use_what_port(){
  echo "    Type 0 or 1 or 2 then hit Enter/Return Key."
  read PORT_CHOICE
   case $PORT_CHOICE in
      0|1|2)          sed -i 's/^\(.*\)port./\1port'$PORT_CHOICE'/' RC1temp.data
      show_current_settings;;
   esac
use_what_port
}

#The following are to give direction of movement for the car, to SI/OP and the store file.
Forward_Full_Speed() {
. ./store_stop_timeRC1.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin6
  echo 0 > /home/siop/$PORT_CHOICE/output/pin7
  echo 0 > /home/siop/$PORT_CHOICE/output/pin8
  echo 1 > /home/siop/$PORT_CHOICE/output/pin9
  echo "#Forward_Full_Speed" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin6" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin7" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin8" >> ${STORE_NAME_VALUE}RC1
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin9" >> ${STORE_NAME_VALUE}RC1
show_current_settings
}

Left_forward() {
. ./store_stop_timeRC1.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC1
  echo 1 > /home/siop/$PORT_CHOICE/output/pin6
  echo 0 > /home/siop/$PORT_CHOICE/output/pin7
  echo 0 > /home/siop/$PORT_CHOICE/output/pin8
  echo 1 > /home/siop/$PORT_CHOICE/output/pin9
  echo "#Left_forward" >> ${STORE_NAME_VALUE}RC1
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin6" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin7" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin8" >> ${STORE_NAME_VALUE}RC1
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin9" >> ${STORE_NAME_VALUE}RC1
show_current_settings
}

Right_forward() {
. ./store_stop_timeRC1.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin6
  echo 1 > /home/siop/$PORT_CHOICE/output/pin7
  echo 0 > /home/siop/$PORT_CHOICE/output/pin8
  echo 1 > /home/siop/$PORT_CHOICE/output/pin9
  echo "#Right_forward" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin6" >> ${STORE_NAME_VALUE}RC1
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin7" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin8" >> ${STORE_NAME_VALUE}RC1
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin9" >> ${STORE_NAME_VALUE}RC1
show_current_settings
}

Left_reverse() {
. ./store_stop_timeRC1.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC1
  echo 1 > /home/siop/$PORT_CHOICE/output/pin6
  echo 0 > /home/siop/$PORT_CHOICE/output/pin7
  echo 1 > /home/siop/$PORT_CHOICE/output/pin8
  echo 0 > /home/siop/$PORT_CHOICE/output/pin9
  echo "#Left_reverse" >> ${STORE_NAME_VALUE}RC1
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin6" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin7" >> ${STORE_NAME_VALUE}RC1
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin8" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin9" >> ${STORE_NAME_VALUE}RC1
show_current_settings
}

Right_reverse() {
. ./store_stop_timeRC1.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin6
  echo 1 > /home/siop/$PORT_CHOICE/output/pin7
  echo 1 > /home/siop/$PORT_CHOICE/output/pin8
  echo 0 > /home/siop/$PORT_CHOICE/output/pin9
  echo "#Right_reverse" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin6" >> ${STORE_NAME_VALUE}RC1
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin7" >> ${STORE_NAME_VALUE}RC1
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin8" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin9" >> ${STORE_NAME_VALUE}RC1
show_current_settings
}

Reverse_Full_Speed() {
. ./store_stop_timeRC1.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin6
  echo 0 > /home/siop/$PORT_CHOICE/output/pin7
  echo 1 > /home/siop/$PORT_CHOICE/output/pin8
  echo 0 > /home/siop/$PORT_CHOICE/output/pin9
  echo "#Reverse_Full_Speed" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin6" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin7" >> ${STORE_NAME_VALUE}RC1
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin8" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin9" >> ${STORE_NAME_VALUE}RC1
show_current_settings
}

#This puts the remote control car at rest and is called for at the starting point and quiting of this script.
Idle() {
. ./store_stop_timeRC1.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin6
  echo 0 > /home/siop/$PORT_CHOICE/output/pin7
  echo 0 > /home/siop/$PORT_CHOICE/output/pin8
  echo 0 > /home/siop/$PORT_CHOICE/output/pin9
  echo "#Idle" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin6" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin7" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin8" >> ${STORE_NAME_VALUE}RC1
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin9" >> ${STORE_NAME_VALUE}RC1
}

#This puts car at idle and quits the script.
clean_up() {
  Idle
  clear
  exit
}

#This returns to main loop.
while true ; do
  show_current_settings
done
echo

