#!/bin/bash
###                                        ###
#      Created on 2/16-2014 by remote.       #
# ZAXTER. home of SI/OP all rights reserved. #
#    Last modified 3/2-2014 via remote.      #
#       Control menu for RC Project.         #
###                                        ###


#This reads data from temp file, creates time stamps and sets up initial states of SI/OP for remote control car two.
. ./RC2temp.data
  echo A="`date +%s`" > store_stop_timeRC2.siop
  sleep .5
  echo B="`date +%s`" >> store_stop_timeRC2.siop
  sed -i "/STORE_NAME_VALUE/ c STORE_NAME_VALUE=default_store_name" RC2temp.data
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin2
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin3
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin4
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin5
. ./RC2temp.data
  echo "#Idle" > ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin2" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin3" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin4" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin5" >> ${STORE_NAME_VALUE}RC2

bs='                                              '

#This is just the header for the main menu.
header() {
  clear
 tput rev
  echo "=============================================="
  echo "             Simple I/O Project.              "
  echo "     SI/OP       move_RC2.sh                  "
  echo "$bs"
 tput rmso
}

#This is the main menu, which displays SI/OP status and reads user input for instructing remote control car two.
show_current_settings() {
. ./RC2temp.data

OLD_INPUT_CHOICE=$(for N in  /home/siop/${PORT_CHOICE}/input/* ; do cat $N ; echo  -n " " ; done | paste -sd " "|sed 's/ /  /g')

OLD_OUTPUT_CHOICE=$(for N in  /home/siop/${PORT_CHOICE}/output/pin2 /home/siop/${PORT_CHOICE}/output/pin3 /home/siop/${PORT_CHOICE}/output/pin4 /home/siop/${PORT_CHOICE}/output/pin5 ; do cat $N ; echo -n " " ; done| paste -sd " "|sed 's/ /  /g')

  clear
header
 tput rev
  echo -n "                  Chosen parallel "
 tput rmso
  echo -n "   $PORT_CHOICE   "
 tput rev
  echo " "
  echo "$bs"
 tput rmso
 tput rev
  echo "                 Output Pins #   2  3  4  5   "
  echo -n "        Current pin states --> "
 tput rmso
  echo -n "  $OLD_OUTPUT_CHOICE"
 tput rev
  echo " "
  echo "$bs"
  echo "           f          Forward Full Speed      "
  echo "         y   u        Left Right forward      "
  echo "         n   m        Left Right reverse      "
  echo "           l          Reverse Full Speed      "
  echo "                                              "
  echo "                                              "
  echo " Type: s to switch recording name.            "
  echo "       r to replay saved.                     "
  echo "       f y u n m l for direction.             "
  echo "       i for idle or p to change port.        "
  echo "       q/0 to quit then hit Enter key.        "
  echo "=============================================="
 tput rmso
  echo -n "  Date & Time:  "
date

#This processes input from menu, replacing time stamps and placement for calculating, then goes to subroutine.
  echo ""
  read SIMPLEIO_MENU
   case $SIMPLEIO_MENU in
       p|P)	use_what_port;;
       f)	B=`head -1 store_stop_timeRC2.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC2.siop; Forward_Full_Speed;;
       y)	B=`head -1 store_stop_timeRC2.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC2.siop; Left_forward;;
       u)	B=`head -1 store_stop_timeRC2.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC2.siop; Right_forward;;
       n)	B=`head -1 store_stop_timeRC2.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC2.siop; Left_reverse;;
       m)	B=`head -1 store_stop_timeRC2.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC2.siop; Right_reverse;;
       l)	B=`head -1 store_stop_timeRC2.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC2.siop; Reverse_Full_Speed;;
       i)	B=`head -1 store_stop_timeRC2.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC2.siop; Idle;;
       s)	Idle; store_replay_name;;
       r)	replay_stored;;
       Q|q|0|Q/0|q/0)	B=`head -1 store_stop_timeRC2.siop | sed 's/A/B/g'`; echo -e "A=`date +%s` \n$B" > store_stop_timeRC2.siop; clean_up;;
   esac
show_current_settings
}

#This updates time stamps, switches name of store file for remote control car two, in RC2temp.data.
store_replay_name(){
. ./RC2temp.data
  echo A="`date +%s`" > store_stop_timeRC2.siop
  sleep .5
  echo B="`date +%s`" >> store_stop_timeRC2.siop
  echo "    Type file name to be stored.      "
  echo "  Currently using: $STORE_NAME_VALUE  "
  read REPLAY_STORE_NAME
   case $REPLAY_STORE_NAME in
       [a-zA-Z0-0]*)	sed -i "/STORE_NAME_VALUE/ c STORE_NAME_VALUE=$REPLAY_STORE_NAME" RC2temp.data
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin2
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin3
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin4
  echo "0" > /home/siop/${PORT_CHOICE}/output/pin5
. ./RC2temp.data
  chmod 0777 ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin2" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin3" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin4" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin5" >> ${STORE_NAME_VALUE}RC2
   show_current_settings;;
   esac
store_replay_name
}

#This needs work, only for my notes.
replay_stored(){
  echo "    Type stored file name.         "
  read REPLAY_STORED
   case $REPLAY_STORED in
       [a-zA-Z0-0]*)	sed -i "/REPLAY_NAME_VALUE/ c REPLAY_NAME_VALUE=$REPLAY_STORED" RC2temp.data
   esac
  echo "    Type amount of times to replay."
  read AMOUNT_REPLAY
   case $AMOUNT_REPLAY in
       [1-99])	sed -i "/AMOUNT_REPLAY_VALUE/ c AMOUNT_REPLAY_VALUE=$AMOUNT_REPLAY" RC2temp.data
   esac
. ./RC2temp.data
  echo " Play file $REPLAY_NAME_VALUE $AMOUNT_REPLAY_VALUE times. "
  echo " Press g then Enter to go.         "
  read FILE_PLUS_AMOUNT
   case $FILE_PLUS_AMOUNT in
       g)	replay;;
   esac
replay_stored
}

#This is to execute replay.
replay(){
. ./RC2temp.data
n=$AMOUNT_REPLAY_VALUE; for (( c=1; c<=n; c++)) ; do ./${REPLAY_NAME_VALUE}RC2 ; done
   show_current_settings
}

#This is to alter which parallel port the cable is plugged into, then returns to main loop.
use_what_port(){
  echo "    Type 0 or 1 or 2 then hit Enter/Return Key."
  read PORT_CHOICE
   case $PORT_CHOICE in
        0|1|2)          sed -i 's/^\(.*\)port./\1port'$PORT_CHOICE'/' RC2temp.data
        show_current_settings;;
   esac
use_what_port
}

#The following are to give dirrection of movement for the car, to SI/OP and the store file.
Forward_Full_Speed() {
  . ./store_stop_timeRC2.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC2
  echo 0 > /home/siop/$PORT_CHOICE/output/pin2
  echo 0 > /home/siop/$PORT_CHOICE/output/pin3
  echo 0 > /home/siop/$PORT_CHOICE/output/pin4
  echo 1 > /home/siop/$PORT_CHOICE/output/pin5
  echo "#Forward_Full_Speed" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin2" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin3" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin4" >> ${STORE_NAME_VALUE}RC2
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin5" >> ${STORE_NAME_VALUE}RC2
}


Left_forward() {
  . ./store_stop_timeRC2.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC2
  echo 1 > /home/siop/$PORT_CHOICE/output/pin2
  echo 0 > /home/siop/$PORT_CHOICE/output/pin3
  echo 0 > /home/siop/$PORT_CHOICE/output/pin4
  echo 1 > /home/siop/$PORT_CHOICE/output/pin5
  echo "#Left_forward" >> ${STORE_NAME_VALUE}RC2
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin2" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin3" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin4" >> ${STORE_NAME_VALUE}RC2
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin5" >> ${STORE_NAME_VALUE}RC2
}

Right_forward() {
  . ./store_stop_timeRC2.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC2
  echo 0 > /home/siop/$PORT_CHOICE/output/pin2
  echo 1 > /home/siop/$PORT_CHOICE/output/pin3
  echo 0 > /home/siop/$PORT_CHOICE/output/pin4
  echo 1 > /home/siop/$PORT_CHOICE/output/pin5
  echo "#Right_forward" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin2" >> ${STORE_NAME_VALUE}RC2
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin3" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin4" >> ${STORE_NAME_VALUE}RC2
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin5" >> ${STORE_NAME_VALUE}RC2
}

Left_reverse() {
  . ./store_stop_timeRC2.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC2
  echo 1 > /home/siop/$PORT_CHOICE/output/pin2
  echo 0 > /home/siop/$PORT_CHOICE/output/pin3
  echo 1 > /home/siop/$PORT_CHOICE/output/pin4
  echo 0 > /home/siop/$PORT_CHOICE/output/pin5
  echo "#Left_reverse" >> ${STORE_NAME_VALUE}RC2
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin2" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin3" >> ${STORE_NAME_VALUE}RC2
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin4" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin5" >> ${STORE_NAME_VALUE}RC2
}

Right_reverse() {
  . ./store_stop_timeRC2.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC2
  echo 0 > /home/siop/$PORT_CHOICE/output/pin2
  echo 1 > /home/siop/$PORT_CHOICE/output/pin3
  echo 1 > /home/siop/$PORT_CHOICE/output/pin4
  echo 0 > /home/siop/$PORT_CHOICE/output/pin5
  echo "#Right_reverse" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin2" >> ${STORE_NAME_VALUE}RC2
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin3" >> ${STORE_NAME_VALUE}RC2
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin4" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin5" >> ${STORE_NAME_VALUE}RC2
}

Reverse_Full_Speed() {
  . ./store_stop_timeRC2.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC2
  echo 0 > /home/siop/$PORT_CHOICE/output/pin2
  echo 0 > /home/siop/$PORT_CHOICE/output/pin3
  echo 1 > /home/siop/$PORT_CHOICE/output/pin4
  echo 0 > /home/siop/$PORT_CHOICE/output/pin5{FILE_PLUS_AMOUNT
  echo "#Reverse_Full_Speed" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin2" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin3" >> ${STORE_NAME_VALUE}RC2
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin4" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin5" >> ${STORE_NAME_VALUE}RC2
}

#This puts the remote control car at rest and is called for at the starting point and quiting of this script.
Idle() {
  . ./store_stop_timeRC2.siop
  BfromA=$(($A-$B))
  echo "sleep $BfromA" >> ${STORE_NAME_VALUE}RC2
  echo 0 > /home/siop/$PORT_CHOICE/output/pin2
  echo 0 > /home/siop/$PORT_CHOICE/output/pin3
  echo 0 > /home/siop/$PORT_CHOICE/output/pin4
  echo 0 > /home/siop/$PORT_CHOICE/output/pin5
  echo "#Idle" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin2" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin3" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin4" >> ${STORE_NAME_VALUE}RC2
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin5" >> ${STORE_NAME_VALUE}RC2
}

#This puts car at idle and quits the script.
clean_up() {
  Idle
  clear
  exit
}

#This returns to main loop.
while true ; do
  show_current_settings
done
echo

