
#!/bin/bash
###                                        ###
#      Created on 2/16-2014 by remote.       #
# ZAXTER. home of SI/OP all rights reserved. #
#    Last modified 2/18-2014 via remote.     #
#                                            #
###                                        ###


#The following is just to give data until altering of A and B is done.
echo "A=3" >> store-stop-timeRC3.siop
echo "B=8" >> store-stop-timeRC3.siop

. ./temp.data
echo "0" > /home/siop/${PORT_CHOICE}/output/pin1
echo "0" > /home/siop/${PORT_CHOICE}/output/pin14
echo "1" > /home/siop/${PORT_CHOICE}/output/pin16
echo "1" > /home/siop/${PORT_CHOICE}/output/pin17

bs='                                              '

header() {
  clear
 tput rev
  echo "=============================================="
  echo "             Simple I/O Project.              "
  echo "     SI/OP       move_RC3.sh                  "
  echo "$bs"
 tput rmso
}

show_current_settings() {
. ./temp.data
. ./store-stop-timeRC3.siop

OLD_INPUT_CHOICE=$(for N in  /home/siop/${PORT_CHOICE}/input/* ; do cat $N ; echo  -n " " ; done | paste -sd " "|sed 's/ /  /g')

OLD_OUTPUT_CHOICE=$(for N in  /home/siop/${PORT_CHOICE}/output/pin1 /home/siop/${PORT_CHOICE}/output/pin14 /home/siop/${PORT_CHOICE}/output/pin16 /home/siop/${PORT_CHOICE}/output/pin17 ; do cat $N ; echo -n " " ; done| paste -sd " "|sed 's/ /  /g')

  clear
header
 tput rev
  echo -n "                  Chosen parallel "
#  echo -n "                         Parallel "
 tput rmso
  echo -n "   $PORT_CHOICE   "
 tput rev
  echo " "
  echo "$bs"
 tput rmso
 tput rev
  echo "                 Output Pins #   3  4  5  6   "
  echo -n "        Current pin states --> "
 tput rmso
  echo -n "  $OLD_OUTPUT_CHOICE"
 tput rev
  echo " "
  echo "$bs"
  echo "           f          Forward Full Speed      "
  echo "           g          Forward 1/2 Speed       "
  echo "           h          Forward 1/4 Speed       "
  echo "         y   u        Left Right forward      "
  echo "         n   m        Left Right reverse      "
  echo "           j          Reverse 1/4 Speed       "
  echo "           k          Reverse 1/2 Speed       "
  echo "           l          Reverse Full Speed      "
  echo "                                              "
  echo " Type: s to start recording.                  "
  echo "       r to replay saved.                     "
  echo "       f g h y u n m j k l for direction.     "
  echo "       i for idle or p to change port.        "
  echo "       q/0 to quit then hit Enter key.        "
  echo "=============================================="
 tput rmso
  echo -n "  Date & Time:  "
date

#Note: I need variable AorB to change between A and B depending on whichever was last sent to
# store-stop-timeRC.siop "which is a flat file", so I can then get the time for sleep.

  echo ""
  read SIMPLEIO_MENU
   case $SIMPLEIO_MENU in
        p|P)	use_what_port;;
        f)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Forward_Full_Speed;;
        g)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Forward_1/2_Speed;;
        h)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Forward_1/4_Speed;;
        y)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Left_forward;;
        u)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Right_forward;;
        n)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Left_reverse;;
        m)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Right_reverse;;
        j)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Reverse_1/4_Speed;;
        k)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Reverse_1/2_Speed;;
        l)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Reverse_Full_Speed;;
        i)	echo AorB="`date +%s`" >> store-stop-timeRC3.siop; Idle;;
        s)	store_name;;
        r)	replay_stored;;
        Q|q|0|Q/0|q/0)	clean_up;;

   esac
show_current_settings
}

#This needs work, only for my notes.
store_name(){
  echo "    Type file name to be stored."
  read STORE_NAME_VALUE
   case $STORE_NAME_VALUE in
  A-Z)
   esac
}

#This needs work, only for my notes.
replay_stored(){
  echo "    Type stored file name."
  read REPLAY_STORED
   case $REPLAY_STORED in
  A-Z)
   esac
  echo "    Type amount of times to replay."
  read AMOUNT_REPLAY
   case $AMOUNT_REPLAY in
  1-999)
   esac
}

use_what_port(){
  echo "    Type 0 or 1 or 2 then hit Enter/Return Key."
  read PORT_CHOICE
   case $PORT_CHOICE in
        0|1|2)          sed -i 's/^\(.*\)port./\1port'$PORT_CHOICE'/' temp.data
        show_current_settings;;
   esac
use_what_port
}

Forward_Full_Speed() {
  echo 0 > /home/siop/$PORT_CHOICE/output/pin1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin14
  echo 0 > /home/siop/$PORT_CHOICE/output/pin16
  echo 1 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Forward_Full_Speed" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

Forward_1/2_Speed() {
  echo 0 > /home/siop/$PORT_CHOICE/output/pin1
  echo 1 > /home/siop/$PORT_CHOICE/output/pin14
  echo 0 > /home/siop/$PORT_CHOICE/output/pin16
  echo 0 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Forward_1/2_Speed" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_I need variable AorB to change from A to B depending on whichever was last sent to store-stop-timeRC1.siop "which is a flat file", so I can then get the time for sleep.CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

Forward_1/4_Speed() {
  echo 0 > /home/siop/$PORT_CHOICE/output/pin1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin14
  echo 0 > /home/siop/$PORT_CHOICE/output/pin16
  echo 0 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Forward_1/4_Speed" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

Left_forward() {
  echo 1 > /home/siop/$PORT_CHOICE/output/pin1
  echo 1 > /home/siop/$PORT_CHOICE/output/pin14
  echo 1 > /home/siop/$PORT_CHOICE/output/pin16
  echo 0 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Left_forward" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

Right_forward() {
  echo 0 > /home/siop/$PORT_CHOICE/output/pin1
  echo 1 > /home/siop/$PORT_CHOICE/output/pin14
  echo 1 > /home/siop/$PORT_CHOICE/output/pin16
  echo 0 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Right_forward" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

Left_reverse() {
  echo 1 > /home/siop/$PORT_CHOICE/output/pin1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin14
  echo 1 > /home/siop/$PORT_CHOICE/output/pin16
  echo 0 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Left_reverse" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

Right_reverse() {
  echo 0 > /home/siop/$PORT_CHOICE/output/pin1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin14
  echo 1 > /home/siop/$PORT_CHOICE/output/pin16
  echo 0 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Right_reverse" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

Reverse_1/4_Speed() {
  echo 1 > /home/siop/$PORT_CHOICE/output/pin1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin14
  echo 0 > /home/siop/$PORT_CHOICE/output/pin16
  echo 0 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Reverse_1/4_Speed" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

Reverse_1/2_Speed() {
  echo 1 > /home/siop/$PORT_CHOICE/output/pin1
  echo 1 > /home/siop/$PORT_CHOICE/output/pin14
  echo 0 > /home/siop/$PORT_CHOICE/output/pin16
  echo 0 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Reverse_1/2_Speed" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

Reverse_Full_Speed() {
  echo 1 > /home/siop/$PORT_CHOICE/output/pin1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin14
  echo 0 > /home/siop/$PORT_CHOICE/output/pin16
  echo 1 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Reverse_Full_Speed" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

Idle() {
  echo 0 > /home/siop/$PORT_CHOICE/output/pin1
  echo 0 > /home/siop/$PORT_CHOICE/output/pin14
  echo 1 > /home/siop/$PORT_CHOICE/output/pin16
  echo 1 > /home/siop/$PORT_CHOICE/output/pin17
  echo "#Idle" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin1" >> store-replay-RC3.siop
  echo "echo 0 > /home/siop/$PORT_CHOICE/output/pin14" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin16" >> store-replay-RC3.siop
  echo "echo 1 > /home/siop/$PORT_CHOICE/output/pin17" >> store-replay-RC3.siop
  source ./store-stop-timeRC3.siop
  AfromB=$(($B-$A))
  echo "sleep $AfromB" >> store-replay-RC3.siop
}

clean_up() {
  Idle
  clear
  exit
}

while true ; do
  show_current_settings
done
echo

